package com.kingdee.shr.compensation.app.integrate;

 
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
 
import com.kingdee.bos.util.EASResource;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.shr.compensation.app.utils.DateRange;
import com.kingdee.shr.compensation.app.utils.SubConstants;
import com.kingdee.shr.compensation.app.utils.SubmitShemeUtils;
import com.kingdee.util.NumericExceptionSubItem;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.apache.commons.lang3.ObjectUtils;
import org.apache.log4j.Logger;



/**
 * ᱨչ
 * @author coyle
 * 20250601
 */
public class BatchSubmitShemeBillControllerBeanEx extends BatchSubmitShemeBillControllerBean {
	private static final Logger logger = Logger.getLogger(BatchSubmitShemeBillControllerBeanEx.class);

	private static  SimpleDateFormat  SDF = new SimpleDateFormat("yyyy-MM-dd");

	private static Map<String,String> FEILDS = new HashMap();


	/**
	 * õ
	 * @param ctx
	 * @param info
	 * @param billId
	 * @throws BOSException
	 * @throws EASBizException
	 */
	protected void setMesData(Context ctx, BatchSubmitShemeBillInfo info, String billId)
			throws BOSException, EASBizException {
		String id = info.getSubmitScheme().getId().toString();
		CalSubmitSchemeInfo calSubmitSchemeInfo = CalSubmitSchemeFactory.getLocalInstance(ctx) .getCalSubmitSchemeInfo(" where id = '" + id + "'");
		if (null != calSubmitSchemeInfo.getSubmitSchemeType() && 4 == calSubmitSchemeInfo.getSubmitSchemeType().getValue()) {
			BatchSubmitShemeBillEntryCollection coll = info.getEntry();
			if (coll.isEmpty()) {
		 		return;
			}
			//
			HashSet<String> selectPerson = new HashSet();
			HashSet<String> selectDate = new HashSet();
			for (int i = 0; i < coll.size(); ++i) {
				BatchSubmitShemeBillEntryInfo entryInfo = coll.get(i);
				String personId = entryInfo.getPerson().getId().toString();
				selectPerson.add(personId);
				Date effectDate = entryInfo.getEffectDate();
				String formattedEffectDate = SDF.format(effectDate);
				selectDate.add(formattedEffectDate);
			 
			}
			// ҳС
			DateRange dateRange = SubmitShemeUtils.findMinMaxDate(selectDate);
			HashMap<String, HashMap> mesData = SubmitShemeUtils.getMesData( ctx, selectPerson, dateRange);
			upMesData(ctx, info ,coll, mesData);

		}
	}

	 

	/**
	 * õ
	 * @param request
	 * @param entrys
	 */
	public static void upMesData(Context ctx,BatchSubmitShemeBillInfo info, BatchSubmitShemeBillEntryCollection entrys,  HashMap<String, HashMap> mesData)  {
		try {
			String[] itemNums = SubConstants.ITEMNUMS;
			if(ObjectUtils.isEmpty(FEILDS)) {
				FEILDS = SubmitShemeUtils.getFeilds(ctx);
			}
		
			String sql = " update T_HR_TimepieceBillEntry  set   " ;
			for(int i =0; i < itemNums.length ;i++ ) {
				String keyF = itemNums[i];
				String sqlFeild = FEILDS.get(keyF);
				sql = sql + sqlFeild + " = ?  " ;
				if(i != itemNums.length -1 ) {
					sql += " , ";
				}
			}
			sql += " where  fid = ? ";
			//µMESݵid;
			Set<String> checkbillIds = new HashSet();
			//sql
			List  paramList = new ArrayList();
			for (int i = 0; i < entrys.size(); i++) {
				BatchSubmitShemeBillEntryInfo entry = entrys.get(i);
				String pId = entry.getPerson().getId().toString();
				Date effectDate = entry.getEffectDate();
				String eDate = SDF.format(effectDate);
				String key = pId + "_" + eDate;
				HashMap valMap = mesData.get(key);
				if (ObjectUtils.isEmpty(valMap)) {
					continue;
				}
				//id
				Object[] paraObj = new Object[itemNums.length + 1];
				setParamsVal(itemNums, checkbillIds, entry, valMap, paraObj); 
				paramList.add(paraObj);
			}
			logger.error("ѯmessql"+sql);
			DbUtil.executeBatch(ctx, sql, paramList);
			logger.error("ύֵɹ");
			//MESݵ״̬
			SubmitShemeUtils.updateInspectionRate(ctx, info, checkbillIds);
		} catch (BOSException e) {
			e.printStackTrace();
		}
	}


	//ֵ;
	private static void setParamsVal(String[] itemNums, Set<String> checkbillIds, BatchSubmitShemeBillEntryInfo entry,
			HashMap valMap, Object[] paraObj) {
		//Ϊ˵û,򲻴,ǰhandler;
		if(ObjectUtils.isEmpty(entry.getId())) {
			return;
		}
		for(int j =0; j < itemNums.length ;j++ ) {
			String keyF = itemNums[j];
			valMap.get(keyF);
			paraObj[j] = valMap.get(FEILDS.get(keyF));
			if( j == itemNums.length-1 ) {
				paraObj[itemNums.length] =  entry.getId().toString();
				checkbillIds.add(FEILDS.get(SubConstants.MESID));
			}
		}
	}

	
	protected void beforeSave(Context ctx, BatchSubmitShemeBillInfo info) throws EASBizException, BOSException {
		if (!"EDIT".equalsIgnoreCase(String.valueOf(info.get("workFlowEdit")))) {
			this.checkBillExists(ctx, info);
		}

		HRBillStateEnum oldBillState = null;
		if (info.getId() != null) {
			BatchSubmitShemeBillCollection billInfoC = this.getBatchSubmitShemeBillCollection(ctx,
					"select id,billState where id = '" + info.getId().toString() + "'");
			oldBillState = billInfoC.isEmpty() ? null : billInfoC.get(0).getBillState();
			//ݸֵ;
			setMesData(ctx, info, info.getId().toString());
		}
		super.checkHRBillWorkFlowIsEdit(ctx, info, oldBillState);
	}
	
	
	
	private void checkBillExists(Context ctx, BatchSubmitShemeBillInfo info) throws EASBizException, BOSException {
		if (BatchSubmitShemeBillFactory.getLocalInstance(ctx)
				.exists("where number = '" + info.getNumber() + "' and billState > 1")) {
			throw new EASBizException(new NumericExceptionSubItem("002", EASResource
					.getString("com.kingdee.shr.compensation.resource.CommonResource", "label191", ctx.getLocale())));
		}
	}

}