package com.kingdee.shr.compensation.web.handler.timepiece.bill;


import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.calcdailypay.IInspectionRate;
import com.kingdee.eas.custom.calcdailypay.InspectionRateCollection;
import com.kingdee.eas.custom.calcdailypay.InspectionRateFactory;
import com.kingdee.eas.custom.calcdailypay.InspectionRateInfo;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.util.ToolUtils;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.compensation.app.integrate.*;
import com.kingdee.shr.compensation.app.utils.DateRange;
import com.kingdee.shr.compensation.app.utils.SubmitShemeUtils;
import com.kingdee.shr.compensation.exception.ExceptionHandle;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.ui.ModelMap;

/**
 * ᱨչ
 * @author coyle
 * 20250520
 */
public class TimepieceSchemeBillEditHandlerEx extends TimepieceSchemeBillEditHandler {

	private static Logger logger = LoggerFactory.getLogger(TimepieceSchemeBillEditHandlerEx.class);
	private static  SimpleDateFormat  SDF = new SimpleDateFormat("yyyy-MM-dd");
	//
//	private static String COMRATE = "MQ005";
//	//λ
//	private static String JOBTYPE = "MQ004";
//	//ܵȼ SKILLLEVEL
//	private static String SKILLLEVEL = "MQ003";
//	//Ƿֳҵ On site
//	private static String ONSITE = "MQ007";
//	//ְ Team app
//	private static String TEAMAPP = "MQ007";
//	// Salary seq
//	private static String SALARYSEQ = "MQ007";
//
//	private static String[] ITEMNUMS = {COMRATE,JOBTYPE,SKILLLEVEL,ONSITE,TEAMAPP,SALARYSEQ};
//
//	private static Map<String,String> FEILDS = new HashMap();




//	public TimepieceSchemeBillEditHandlerEx() throws BOSException {
//		Context ctx = SHRContext.getInstance().getContext();
//		CalSubmitItemCollection subColl = CalSubmitItemFactory.getLocalInstance(ctx)
//				.getCalSubmitItemCollection("SELECT ID,FieldSn,number  where  number in (" + ToolUtils.aryToStr(ITEMNUMS) + ")");
//		if (subColl != null && subColl.size() > 0) {
//			for (int i =0 ;i<subColl.size();i++) {
//				CalSubmitItemInfo itemInfo = subColl.get(i);
//				if (itemInfo != null) {
//					String columnName = "S" + itemInfo.getFieldSn();
//					FEILDS.put(itemInfo.getNumber() , columnName);
//				}
//			}
//		}
//	}



	protected void beforeSave(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model)
			throws SHRWebException {
		super.beforeSave(request, response, model);
		Context ctx = SHRContext.getInstance().getContext();
		BatchSubmitShemeBillInfo info = (BatchSubmitShemeBillInfo) model;
		BatchSubmitShemeBillEntryCollection entry = info.getEntry();
		String billId = "";
		if(ObjectUtils.allNotNull(info.getId())) {
			billId = info.getId().toString();
		}
		//ȡmes
		exeDataOnDay( request,billId,entry);
		//õʱʶ
		SubmitShemeUtils.reductionInspectionRate( ctx, info);
		//µ
		Set<String> checkbillIds = (Set<String> ) request.getAttribute("checkbillIds");
		SubmitShemeUtils.updateInspectionRate(ctx, info,checkbillIds);
	}





	/**
	 * ݴ
	 * УӦĳһѴ/mesݻȡ
	 * @param billId
	 * @param entrys
	 * @throws SHRWebException
	 */
	public void exeDataOnDay(HttpServletRequest request,String billId,BatchSubmitShemeBillEntryCollection entrys) throws SHRWebException {
		Context ctx = SHRContext.getInstance().getContext();
		Map<String, Set<String>> personDateMap = new HashMap<>();
		//
		HashSet<String> selectPerson = new HashSet();
		HashSet<String> selectDate = new HashSet();
		for (int i = 0; i < entrys.size(); i++) {
			BatchSubmitShemeBillEntryInfo entry = entrys.get(i);
			String personId = entry.getPerson().getId().toString();
			selectPerson.add(personId);
			Date effectDate = entry.getEffectDate();
			// Ӷ effectDate Ϊ null ļ
			if (effectDate == null) {
				throw new IllegalArgumentException("¼зڲΪ,");
			}
			String formattedEffectDate = SDF.format(effectDate);
			selectDate.add(formattedEffectDate);
			// ʹ computeIfAbsent 룬ظ
			personDateMap.computeIfAbsent(personId, k -> new HashSet<>());
			if (!personDateMap.get(personId).add(formattedEffectDate)) {
				//  add  false˵Ѿڣ׳쳣
				throw new IllegalArgumentException("¼" + entry.getPerson().getName() + ",еظᱨ,");
			}

		}

		if (personDateMap.isEmpty()) {
			return;
		}
		// ҳС
		DateRange dateRange = SubmitShemeUtils.findMinMaxDate(selectDate);
		//Уظ
		verifiOneData(ctx, billId, selectPerson, dateRange, personDateMap);
		//Уmes;
		//ȡmes
		HashMap<String, HashMap> mesData = SubmitShemeUtils.getMesData( ctx, selectPerson, dateRange);
		SubmitShemeUtils.setMesData( request, entrys, mesData);
	}






	/**
	 * У鵱Ƿظ
	 * @param ctx
	 * @param billId
	 * @param selectPerson
	 * @param dateRange
	 * @param personDateMap
	 * @throws SHRWebException
	 */
	public void verifiOneData(Context ctx ,String billId,HashSet<String> selectPerson,DateRange dateRange,Map<String, Set<String>> personDateMap) throws SHRWebException {
		HashMap<String,String> dataMap = new HashMap();
		try {
			IBatchSubmitShemeBillEntry entryIns = BatchSubmitShemeBillEntryFactory.getLocalInstance(ctx);
			FilterInfo filter = new FilterInfo();
			filter.getFilterItems().add(new FilterItemInfo("person", selectPerson, CompareType.INCLUDE));
			filter.getFilterItems().add(new FilterItemInfo("bill.id",   billId , CompareType.NOTEQUALS  ));
			filter.getFilterItems().add(new FilterItemInfo("effectDate",  dateRange.getMaxDate() , CompareType.LESS_EQUALS));
			filter.getFilterItems().add(new FilterItemInfo("effectDate",  dateRange.getMinDate() , CompareType.GREATER_EQUALS  ));
			EntityViewInfo viewInfo = new EntityViewInfo();
			SelectorItemCollection selector = viewInfo.getSelector();
			selector.add(new SelectorItemInfo("person.id"));
			selector.add(new SelectorItemInfo("person.name"));
			selector.add(new SelectorItemInfo("bill.number"));
			selector.add(new SelectorItemInfo("effectDate"));
			viewInfo.setFilter(filter);
			BatchSubmitShemeBillEntryCollection entryCol = entryIns.getBatchSubmitShemeBillEntryCollection(viewInfo);
			for(int i = 0;i<entryCol.size();i++) {
				BatchSubmitShemeBillEntryInfo entryInfo  = entryCol.get(i);
				Date effectDate = entryInfo.getEffectDate();
				String  personId = entryInfo.getPerson().getId().toString();
				Set<String> pAndDate = personDateMap.get(personId);
				if(pAndDate.contains(SDF.format(effectDate))) {
					String  personName = entryInfo.getPerson().getName().toString();
					BatchSubmitShemeBillInfo billInfo = entryInfo.getBill();
					String billNo = billInfo.getNumber();
					dataMap.put(personName, billNo);
				}
			}

		} catch (BOSException e) {
			e.printStackTrace();
		}
		//dataMapΪѭdataMapַ׳쳣,"Щ,ݱΪ:****"
		if(!dataMap.isEmpty()) {
			String errorMsg = "µظᱨԱ,뵥ݱΪ:";
			for(String personName : dataMap.keySet()) {
				String billNo = dataMap.get(personName);
				errorMsg += personName + ":" + billNo + "  ";
			}
			throw new SHRWebException(errorMsg);
		}
	}



	



	/**
	 * handlerУ,Ȳ
	 * @param request
	 * @param response
	 * @param modelMap
	 * @throws SHRWebException
	 */
	public void hasDataOnDayAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
			throws SHRWebException {
		Context ctx = SHRContext.getInstance().getContext();
		// ȡԱ //ʽΪ[pseron1:2025-04-03,person2:2025-04-03],ҪתΪmap
		String proposers = request.getParameter("proposers");
		if (proposers == null || proposers.isEmpty()) {
			return;
		}

		String[] personArr = proposers.split(",");
		HashSet<String> selectPerson = new HashSet();
		HashSet<String> selectData = new HashSet();
		Map<String, Set<String>> personDateMap = new HashMap<>();
		for (int i = 0; i< personArr.length;i++) {
			String personIds = personArr[i];
			String[] parts = personIds.split(":");
			if (parts.length == 2) {
				String personId = parts[0].trim();
				String date = parts[1].trim();
				selectPerson.add(personId);
				selectData.add(date);
				personDateMap.computeIfAbsent(personId, k -> new HashSet<>()).add(date);
			}
		}

		if (personDateMap.isEmpty()) {
			return;
		}

		HashMap<String,String> dataMap = new HashMap();

		// ҳС
		DateRange dateRange = SubmitShemeUtils.findMinMaxDate(selectData);
		IBatchSubmitShemeBillEntry entryIns;
		try {
			entryIns = BatchSubmitShemeBillEntryFactory.getLocalInstance(ctx);
			FilterInfo filter = new FilterInfo();
			filter.getFilterItems().add(new FilterItemInfo("proposer", selectPerson, CompareType.INCLUDE));
			filter.getFilterItems().add(new FilterItemInfo("effectDate",  dateRange.getMaxDate() , CompareType.LESS_EQUALS));
			filter.getFilterItems().add(new FilterItemInfo("effectDate",  dateRange.getMinDate() , CompareType.GREATER_EQUALS  ));
			EntityViewInfo viewInfo = new EntityViewInfo();
			viewInfo.setFilter(filter);
			BatchSubmitShemeBillEntryCollection entryCol = entryIns.getBatchSubmitShemeBillEntryCollection(viewInfo);
			for(int i = 0;i<entryCol.size();i++) {
				BatchSubmitShemeBillEntryInfo entryInfo  = entryCol.get(i);
				Date effectDate = entryInfo.getEffectDate();
				String  personId = entryInfo.getPerson().getId().toString();
				Set<String> pAndDate = personDateMap.get(personId);
				if(pAndDate.contains(SDF.format(effectDate))) {
					String  personName = entryInfo.getPerson().getName().toString();
					BatchSubmitShemeBillInfo billInfo = entryInfo.getBill();
					String billNo = billInfo.getNumber();
					dataMap.put(personName, billNo);
				}
			}

		} catch (BOSException e) {
			e.printStackTrace();
		}
		Map resultMap = new HashMap();
		JSONUtils.SUCCESS( resultMap );
	}





 



	protected void afterSave(HttpServletRequest request, HttpServletResponse response, CoreBaseInfo model)
			throws SHRWebException {
		super.afterSave(request, response, model);
		Context ctx = SHRContext.getInstance().getContext();
		BatchSubmitShemeBillInfo info = (BatchSubmitShemeBillInfo) model;
		BatchSubmitShemeBillEntryCollection entry = info.getEntry();
	

	}




	 


//	public void getDataOnDay(String billId,BatchSubmitShemeBillEntryCollection entrys) throws SHRWebException {
//		Context ctx = SHRContext.getInstance().getContext();
//		Map<String, Set<String>> personDateMap = new HashMap<>();
//		//
//		HashSet<String> selectPerson = new HashSet();
//		HashSet<String> selectDate = new HashSet();
//		for (int i = 0; i < entrys.size(); i++) {
//			BatchSubmitShemeBillEntryInfo entry = entrys.get(i);
//			String personId = entry.getPerson().getId().toString();
//			selectPerson.add(personId);
//			Date effectDate = entry.getEffectDate();
//
//			String formattedEffectDate = SDF.format(effectDate);
//			selectDate.add(formattedEffectDate);
//			// ʹ computeIfAbsent 룬ظ
//			personDateMap.computeIfAbsent(personId, k -> new HashSet<>());
//			if (!personDateMap.get(personId).add(formattedEffectDate)) {
//				//  add  false˵Ѿڣ׳쳣
//				throw new IllegalArgumentException("¼" + entry.getPerson().getName() + ",еظᱨ,");
//			}
//		}
//
//		if (personDateMap.isEmpty()) {
//			return;
//		}
//		// ҳС
//		DateRange dateRange = findMinMaxDate(selectDate);
//		//Уظ
//		verifiOneData(ctx, billId, selectPerson, dateRange, personDateMap);
//		//ȡmes
//		HashMap<String, HashMap> mesData = getMesData(ctx, selectPerson, dateRange);
//		setMesData(ctx, billId, entrys, mesData);
//	}


	public String saveAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap)
			throws SHRWebException {
		try {
			BatchSubmitShemeBillInfo model = (BatchSubmitShemeBillInfo) request.getAttribute("dynamic_model");
			this.doFieldPermFilterSave(request, model);
			this.doSave(request, response, model);
			this.afterSave(request, response, model);
			this.saveAttachment(request, response, model);
			Object responseData = this.generateResponseDataAfterSave(request, response, model);
			Map  resultMap = new HashMap();
			resultMap.put("responseData", responseData);
			resultMap.put("assignedRowsCount", request.getAttribute("assignedRowsCount"));
			this.writeSuccessData(resultMap);
		} catch (Exception var6) {
			ExceptionHandle.handleException(var6);
		}

		return null;
	}





	




//	/**
//	 * ɾ
//	 */
//	@Override
//	public String deleteAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
//		String returnStr = super.deleteAction(request, response, modelMap);
//		reductionAllInsRate(request);
//		return  returnStr ;
//	}


//	/**
//	 * е
//	 * @param request
//	 * @throws SHRWebException
//	 */
//	private void  reductionAllInsRate (HttpServletRequest request) throws SHRWebException {
//		String billId = getBillId(request);
//		String[] ids = billId.split(",");
//        //idsתΪlist
//        List<String> idList = Arrays.asList(ids);
//
//        Context ctx = SHRContext.getInstance().getContext();
//        FilterInfo filter = new FilterInfo();
//        filter.getFilterItems().add(new FilterItemInfo("id", ToolUtils.aryToStr(idList,false), CompareType.INCLUDE));
//		EntityViewInfo viewInfo = new EntityViewInfo( ) ;
//		viewInfo.setFilter(filter);
//		SelectorItemCollection selector = viewInfo.getSelector();
//		selector.add(new SelectorItemInfo("number"));
//		try {
//			IBatchSubmitShemeBill subIns = BatchSubmitShemeBillFactory.getLocalInstance(ctx);
//			BatchSubmitShemeBillCollection   subCol =  subIns.getBatchSubmitShemeBillCollection(viewInfo);
//			for(int i = 0;i<subCol.size();i++){
//				BatchSubmitShemeBillInfo subInfo = subCol.get(i);
//				SubmitShemeUtils.reductionInspectionRate(ctx, subInfo);
//			}
//		} catch (BOSException e) {
//			throw new RuntimeException(e);
//		}
//	}
}