package com.kingdee.shr.compensation.web.handler.timepiece.bill;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.base.permission.util.ToolUtils;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.calcdailypay.IInspectionRate;
import com.kingdee.eas.custom.calcdailypay.InspectionRateCollection;
import com.kingdee.eas.custom.calcdailypay.InspectionRateFactory;
import com.kingdee.eas.custom.calcdailypay.InspectionRateInfo;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillCollection;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillFactory;
import com.kingdee.shr.compensation.app.integrate.BatchSubmitShemeBillInfo;
import com.kingdee.shr.compensation.app.integrate.IBatchSubmitShemeBill;
import com.kingdee.shr.compensation.app.utils.SubmitShemeUtils;

import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;
import java.util.List;


/**
 * ᱨչ
 * @author coyle
 * 20250520
 */
public class TimepieceSchemeBillListHandlerEx extends TimepieceSchemeBillListHandler {



    private static Logger logger = LoggerFactory.getLogger(TimepieceSchemeBillListHandlerEx.class);
    /**
     * ɾ
     */
    @Override
    public String deleteAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
    	reductionAllInsRate(request);
        String returnStr = super.deleteAction(request, response, modelMap);
        return  returnStr ;
    }



    /**
     * е
     * @param request
     * @throws SHRWebException
     */
    private void  reductionAllInsRate (HttpServletRequest request) throws SHRWebException {
        String billId = getBillId(request);
        String[] ids = billId.split(",");
        //idsתΪlist
        List<String> idList = Arrays.asList(ids);

        Context ctx = SHRContext.getInstance().getContext();
        FilterInfo filter = new FilterInfo();
        filter.getFilterItems().add(new FilterItemInfo("id", ToolUtils.aryToStr(idList,false), CompareType.INCLUDE));
        EntityViewInfo viewInfo = new EntityViewInfo( ) ;
        viewInfo.setFilter(filter);
        SelectorItemCollection selector = viewInfo.getSelector();
        selector.add(new SelectorItemInfo("number"));
        try {
            IBatchSubmitShemeBill subIns = BatchSubmitShemeBillFactory.getLocalInstance(ctx);
            BatchSubmitShemeBillCollection subCol =  subIns.getBatchSubmitShemeBillCollection(viewInfo);
            for(int i = 0;i<subCol.size();i++){
                BatchSubmitShemeBillInfo subInfo = subCol.get(i);
                SubmitShemeUtils.reductionInspectionRate(ctx, subInfo);
            }
        } catch (BOSException e) {
            throw new RuntimeException(e);
        }
    }




  




}